# This script is a fix of two scripts,
# the first by sicman_adrian (http://forums.mattie.info/cs/forums/viewtopic.php?p=250741&highlight=fall#250710)
# the second by jeff91 (http://forums.mattie.info/cs/forums/viewtopic.php?p=250753#250808)
# released on request by PatPeter

# requires ES 2.0+, ES_tools or source python extensions

import es

class est: #yup, it ignores passed arguments o.~
    @staticmethod
    def registerPreHook(event, func):
        es.server.cmd('est_RegEventBlock player_falldamage "es_xdoblock falldamage/pre_falldamage"')
    @staticmethod
    def unregisterPreHook(event, func):
        es.server.cmd('est_UnRegEventBlock player_falldamage "es_xdoblock falldamage/pre_falldamage"')
        
using = 'spe'
try:
   import spe
except ImportError:
   spe = est()
   using = 'est'

info = es.AddonInfo()
info.name     = "Anti Fall Damage"
info.version  = "2.1"
info.url      = "http://forums.mattie.info/cs/forums/viewtopic.php?t=30462"
info.basename = "falldamage"
info.author   = "DanielB"
es.ServerVar('afd_danielb_ver', info.version, 'AntiFall Damage - mp_falldamage fix').makepublic()

mp_falldamage = es.ServerVar('mp_falldamage')

def load():
    spe.registerPreHook('player_falldamage', pre_falldamage)
    es.msg('#multi', '#green[AntiFallDamage]#lightgreen Loaded (using %s)'%using)

def unload():
    spe.unregisterPreHook('player_falldamage', pre_falldamage)
    es.msg('#multi', '#green[AntiFallDamage]#lightgreen Unloaded')

def returnEV(var):
    val = es.ServerVar('afd_tmp')
    val.set(0)
    es.server.cmd('est_GetEventInfo afd_tmp '+var)
    return val

def getVars():
    ret = {}
    ret['userid'] = str(returnEV('userid'))
    ret['damage'] = int(returnEV('damage'))
    return ret

def pre_falldamage(ev=None):
    if not int(mp_falldamage):
        if ev is None: ev = getVars()
        userid = ev['userid']
        dmg = ev['damage']
        health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health + dmg)
